#include <GL/glut.h>

// Zobrazenie štvorca
void display() {
	// Vyčistenie pozadia
	glClear(GL_COLOR_BUFFER_BIT);

	// Vykreslenie jednotlivých bodov. GPU vie vykresľovať iba trojuholníky,
	// preto sa štvorec vykreslí ako 2 trojuholníky. OpenGL je implementované ako
	// stavový automat, prto sa určuje farba vertexu pred odoslaním do GPU.
	glBegin(GL_TRIANGLE_STRIP);
		glColor3f(1, 0, 0); glVertex3f(-0.9, -0.9, 0);
		glColor3f(0, 1, 0); glVertex3f(-0.9,  0.9, 0);
		glColor3f(0, 0, 1); glVertex3f( 0.9, -0.9, 0);
		glColor3f(1, 1, 1); glVertex3f( 0.9,  0.9, 0);
	glEnd();

	// Ukončenie definície objektov a vykreslenie na obrazovku
	glFlush();
}

// Inicializácia OpenGL a hlavnej slučky
int main(int argc, char** argv) {

	// Režim RGB bez double bufferu
	glutInit(&argc, argv);
	glutInitDisplayMode(GLUT_SINGLE | GLUT_RGB);

	// Vytvorenie okna
	glutInitWindowSize(400, 300);
	glutCreateWindow("Okno");

	// Zaregistrovanie funkcie, ktorá vykreslí obsah okna
	glutDisplayFunc(display);

	// Hlavná slučka, ktorá bude bežať až kým užívateľ nezatvorí okno
	glutMainLoop();
}
